\section{\LARGE Examples \label{sec:examples}}

%\noindent
%Note that currently reading and writing of PAX event interpretations
%to a file is directly dependent on ROOT I/O.
%Within CDF software, the dependence on the ROOT version is automatically
%taken care off.
\subsection{\LARGE Fill and print event interpretation \label{sec:firstexample}}

\noindent
The easiest way of getting an event interpretation is a copy of the
reconstruction output of the experiment.\\
In the example below, we use calorimeter information together with the vertices 
of the i-th event.
In the function {\bf\red FillCalorimeter}, the calorimeter towers of the Stntuple 
class {\bf\blue TCalTower} are filled into {\bf\red PaxFourVector}'s with
name=``caltower''. 
The vertices of the class {\bf\blue TStnVertex} are filled into {\bf\red PaxVertex} 
instances. 
The relations of the calorimeter towers to the primary vertex 
(name=``primary vertex'') are setup. 
Relations to the original Stntuple class instances are added for all vertices 
and fourvectors. 
All the fourvectors, vertices and their relations are registered in the event 
interpretation ``calorimeter'':


\noindent
{\bf\red \#include "TPAXAnaModule.hh"}\\
{\bf\red \#include "PAX/PAXinterpret.hh"}\\
\\
// create instance of an empty event interpretation \\
{\bf\red   PaxEventInterpret* calorimeter = new PaxEventInterpret;}\\
\\
// for the i-th event (ievent) fill towers and vertices into \\
// the event interpretation calorimeter, and setup all relations:\\
{\bf\red   FillCalorimeter( calorimeter, ievent );}\\
\\
// print all information available to the event interpretation\\
{\bf\red   calorimeter--$>$Print();}\\
\\
// delete event interpretation\\
{\bf\red  delete calorimeter;}

\noindent
The printout you will get contains all the information which is 
available to the pax event interpretation ``calorimeter''
{\em (a few further comments are added below)}:\\
**************************************************************************\\
*  {\bf\blue PaxEventInterpret}::print\\
*  PaxId = 1  {\em (pax objects have a unique identifier PaxId),}$\;$  name = calorimeter towers\\
**************************************************************************\\
*******************************\\
PaxEventInterpret::print: {\bf\blue Vertices}   \\
*******************************\\
number of vertices= 1\\
=================================================\\
PaxId=2 name ={\bf\blue primary vertex x=-0.06642 y=0.312754 z=5.42354} status =0 locked =0\\
...................................................................\\
{\bf\blue PaxVertexRelations}::print: total number of members=1 {\em (required for analysis history and the exclusion mechanism)}\\
PaxId=2 name =primary vertex x=-0.06642 y=0.312754 z=5.42354 status =0 locked =0\\
...................................................................\\
{\bf\blue PaxOutgoingFourVectorRelations}::print:  total number of fourvectors=603 {\em (required for decay chains)}\\
PaxId=1208 name =caltower px=0.229736 py=-0.0302453 pz=3.0462 e=3.055 charge=0 mass=0 id=0 status=0 simulated=0 workflag=0 locked=0\\
...\\
...................................................................\\
ExperimentClassRelationsMap: {\bf\blue PaxExperimentClassRelations} name= TStnVertex {\em (enables access to the original CDF class member functions)}\\
PaxExperimentClassRelations::print:  total number of relations=1\\
related experimentclass key=0\\
----------------------------------\\
**********************************\\
PaxEventInterpret::print: {\bf\blue FourVectors}\\
**********************************\\
number of fourvectors= 603\\
=================================================\\
PaxId=1208 name ={\bf\blue caltower px=0.229736 py=-0.0302453 pz=3.0462 e=3.055} charge=0 mass=0 id=0 status=0 simulated=0 workflag=0 locked=0\\
...................................................................\\
{\bf\blue PaxBeginVertexRelations}::print: total number of members=1 {\em (required for decay chains)}\\
PaxId=2 name =primary vertex x=-0.06642 y=0.312754 z=5.42354 status =0 locked =0\\
...................................................................\\
{\bf\blue PaxFourVectorRelations}::print:  total number of fourvectors=1 {\em (required for analysis history and the exclusion mechanism)}\\
PaxId=1208 name =caltower px=0.229736 py=-0.0302453 pz=3.0462 e=3.055 charge=0 mass=0 id=0 status=0 simulated=0 workflag=0 locked=0\\
...................................................................\\
ExperimentClassRelationsMap: {\bf\blue PaxExperimentClassRelations} name= TCalTower {\em (enables access to the original CDF class member functions)}\\
PaxExperimentClassRelations::print:  total number of relations=1\\
related experimentclass key=12055\\
...\\

\noindent
If you prefer the kinematics in the form of (pt,eta,phi) instead of (px,py,pz) use the PAX printlevels
(section \ref{printlevel})\\
{\bf\red   calorimeter--$>$Print(PAX$\_$PT);}\\
If the ouput is too elaborate for your taste try \\
{\bf\red   calorimeter--$>$Print(PAX$\_$PTSHORT);}


\subsection{\LARGE Loop over PaxFourVectors, histogram their transverse momenta  }

\noindent
Here we sketch the begin-job, event loop, end-job structure,
to indicate the complete procedure to arrive at the histogram on disk.

\noindent
{\bf\red \#include "TPAXAnaModule.hh"}\\
{\bf\red \#include "PAX/PAXinterpret.hh"}\\
\\
{\bf\red   \#include $<$TFile.h$>$}\\
{\bf\red   \#include $<$TH1.h$>$}\\
\\
// ---------- begin job ----------- \\
// root file\\
{\bf\red   TFile* file  = new TFile("pax.root","RECREATE");}\\
// book histogram\\
{\bf\red   TH1F* hist$\_$pt = new TH1F( "pt" , "pt ", 100, 0., 100. );}\\
\\
// ---------- during event processing ----------- \\
...\\
// get iterator for fourvectors from PaxEventInterpret instance calorimeter of
section \ref{sec:firstexample} \\ 
{\bf\red   PaxIterator$<$PaxFourVector* $>$* iter = calorimeter--$>$fourvector--$>$GetIterator();}\\
\\
// loop over PaxFourVector instances and fill histogram\\
{\bf\red   for ( iter--$>$First(); !iter--$>$IsDone(); iter--$>$Next() )}\\
{\bf\red   hist$\_$pt--$>$Fill( iter--$>$CurrentItem()--$>$Pt() );}\\
\\
// ---------- end job ----------- \\
// write histograms to file\\
{\bf\red   hist$\_$pt--$>$Write();}\\
{\bf\red   file--$>$Write();}\\
{\bf\red   file--$>$Close();}\\
{\bf\red   delete hist$\_$pt;}\\
{\bf\red   delete file;}\\


\subsection{\LARGE Loop over PaxVertex related PaxFourVector's  }

\noindent
Find the primary vertex and print the pseudo-rapidities of the 
fourvectors originating from the primary vertex.\\
\\
{\bf\red \#include "TPAXAnaModule.hh"}\\
{\bf\red \#include "PAX/PAXinterpret.hh"}\\
\\
// get iterator for vertices from event interpret calorimeter of section \ref{sec:firstexample}\\
{\bf\red      PaxIterator$<$PaxVertex* $>$*  itervx = calorimeter--$>$vertex--$>$GetIterator();}\\
\\
// loop over vertices \\
{\bf\red      for (itervx--$>$First(); !itervx--$>$IsDone(); itervx--$>$Next() )}\\
{\bf\red      \{ }\\
{\bf\red         if ( itervx--$>$CurrentItem()--$>$GetPaxName() == "primary vertex" ) }\\
{\bf\red          \{ }\\
// get iterator for fourvectors via the outgoing fourvector relations\\
// of the vertices of event interpret calorimeter\\
{\bf\red            PaxIterator$<$PaxFourVector* $>$* iterfv;}\\
{\bf\red iterfv = itervx--$>$CurrentItem()--$>$outgoing$\_$fourvector$\_$relations--$>$GetIterator();}\\
\\
// loop and print pseudo-rapidity of fourvectors\\
{\bf\red            for ( iterfv--$>$First(); !iterfv--$>$IsDone(); iterfv--$>$Next() )}\\
{\bf\red            cout $<<$ "pseudo-rapidity = " $<<$ iterfv--$>$CurrentItem()--$>$Eta() $<<$ endl;}\\
{\bf\red          \};     \}; }


\subsection{\LARGE Access original member function of CDF class  }

\noindent
Information needed from the Stntuple reconstruction output is 
best accessed within the interface functions to the experiment 
data (e.g. FillCalorimeter, see section \ref{sec:firstexample}).
There the best knowledge should be passed to the 
event interpretations of PAX in terms of vertices, 
fourvectors, etc.
Nevertheless there is a way to recover the original 
pointer to the instance of a CDF detector class and access
its member function.
As an example we use the class TCalTower below.\\
\\
{\bf\red \#include "TPAXAnaModule.hh"}\\
{\bf\red \#include "PAX/PAXinterpret.hh"}\\
\\
{\bf\red \#include "Stntuple/data/TCalTower.hh" } \\
 \\
// the name of the experiment class manager corresponds to the CDF class name\\
{\bf\red string experiment$\_$class$\_$manager="TCalTower"; } \\
\\
  // get iterator for fourvectors from event interpretation calorimeter 
 of section \ref{sec:firstexample}\\ 
{\bf\red PaxIterator$<$PaxFourVector* $>$* iterfv = calorimeter--$>$fourvector--$>$GetIterator(); } \\
// loop over all fourvectors\\
{\bf\red for (iterfv--$>$First(); !iterfv--$>$IsDone(); iterfv--$>$Next() ) } \\
{\bf\red      \{ } \\
// check whether a relation manager has been registered with the name TCalTower \\
{\bf\red if ( iterfv--$>$CurrentItem()}\\
{\bf\red --$>$map$\_$experimentclass$\_$relations--$>$FindItemByKey( experiment$\_$class$\_$manager )) } \\
{\bf\red  \{ } \\
// in general, many instances of TCalTower may be related to a fourvector, e.g. in the case of jets.\\
// Get iterator for the experiment class from the relation manager \\
{\bf\red PaxIterator$<$PaxExperimentClass* $>$* iterec = iterfv--$>$CurrentItem()}\\
{\bf\red --$>$map$\_$experimentclass$\_$relations--$>$FindItemByKey( experiment$\_$class$\_$manager )}\\
{\bf\red --$>$GetIterator(); } \\
\\          
// loop over the relations to the CDF class (here only one) \\
{\bf\red for (iterec--$>$First(); !iterec--$>$IsDone(); iterec--$>$Next() ) } \\
{\bf\red \{  } \\
// downcast from pax experiment class to detector class \\
{\bf\red PaxExperiment$<$TCalTower$>$* detector } \\
{\bf\red = dynamic$\_$cast$<$PaxExperiment$<$TCalTower$>$* $>$(iterec--$>$CurrentItem()); } \\
\\
// print the eta-phi index, note that EtaPhi() is a member function of the class TCalTower \\
{\bf\red               cout  $<<$ "eta-phi index = " $<<$ detector--$>$GetData()--$>$EtaPhi() $<<$ endl; } \\
{\bf\red      \};      \};      \}; }

\noindent
A life example of accessing the member function of a CDF class 
can be found in the function {\bf\blue MergeElectrons} (subdirectory Stntuple/PAX).
MergeElectrons merges a calorimeter event interpretation and an electron
event interpretation into one combined event interpretation without double
counting of energy.
The electrons are found within the calorimeter event interpretation
by the eta-phi tower assignment. The calorimeter tower energy is then
replaced by the kinematics of the electron.
On return, MergeElectrons gives the number of successfully merged electrons.

\subsection{\LARGE Reconstruct W bosons in leptonic decays}

\noindent
The example algorithm {\bf\blue MakeW} (subdirectory Stntuple/PAX) reconstructs the decay chain 
W --$>$ lepton + neutrino from a W-mass constraint.
The algorithm uses on input an event interpretation, a lepton 
fourvector of this input event interpretation, missing 
transverse momentum components px, py, and a value for the 
W-boson mass.
\\
On output it delivers two event interpretations corresponding
to two solutions of the reconstructed W boson.
If the solutions are identical, only one event interpretation
is filled, the second remains empty.
On return, the number of W solutions is given.

\noindent
{\bf\red \#include "TPAXAnaModule.hh"}\\
{\bf\red \#include "PAX/PAXinterpret.hh"}\\
\\
// create empty event interpretation \\
{\bf\red PaxEventInterpret* electron$\_$event$\_$interpretation = new PaxEventInterpret;}\\
// for the i-th event fill event interpretation with electron data \\
{\bf\red FillElectrons( electron$\_$event$\_$interpretation, ientry );}\\
// get first electron \\
{\bf\red PaxFourVector* electron=0;}\\
{\bf\red PaxIterator$<$PaxFourVector*$>$* iter } \\
{\bf\red = electron$\_$event$\_$interpretation--$>$fourvector--$>$GetIterator();}\\
{\bf\red iter--$>$First();}\\ 
{\bf\red if ( !iter--$>$IsDone() ) electron = iter--$>$CurrentItem(); }\\
\\
// create two empty event interpretations for two possible W solutions\\
{\bf\red PaxEventInterpret* W1 = new PaxEventInterpret;}\\
{\bf\red PaxEventInterpret* W2 = new PaxEventInterpret;}\\
\\
// fill the two event interpretations, take px and py from Stntuple, W$\_$mass=80.42 GeV\\
{\bf\red int n$\_$W = MakeW( electron$\_$event$\_$interpretation, W1, W2, electron, px, py, W$\_$mass );}\\
// print the results\\
{\bf\red cout $<<$ "number of W =" $<<$ n$\_$W $<<$ endl;}\\
{\bf\red W1--$>$Print();}\\
{\bf\red W2--$>$Print();}\\
\\
// clear memory\\
{\bf\red delete electron$\_$event$\_$interpretation;}\\
{\bf\red delete W1;}\\
{\bf\red delete W2;}\\

\subsection{\LARGE  Write event interpretations to file, read from file}

\noindent
{\bf\red \#include "PAX/PAXinterpret.hh"}\\
{\bf\red \#include "PAX/PAXfile.hh"}\\
{\bf\red \#include $<$TFile.h$>$}\\
\\
// open file in write mode \\
{\bf\red PaxFile* file = new PaxFile("myfile.root",PaxFile::Write);}\\
// create new event interpretation \\
{\bf\red PaxEventInterpret* calorimeter = new PaxEventInterpret;}\\
// fill calorimeter ..., then store event interpretation to file \\
{\bf\red calorimeter--$>$Store(file);}\\
// perhaps you want to store several event interpretations in the event...\\
// once the event is complete write the end-of-event marker\\
{\bf\red file--$>$WriteEvent();}\\
{\bf\red delete calorimeter;}\\
// ... write next event..., finally close and delete the event file\\
{\bf\red file--$>$Close();}\\
{\bf\red delete file; }\\

\noindent
// open file in read mode \\
{\bf\red PaxFile* file = new PaxFile("myfile.root",PaxFile::Read);}\\
// read event into internal buffer, recover all relations between the 
event interpretations of this event \\
{\bf\red if (!file--$>$EndOfFile()) { file--$>$ReadEvent(); }}\\
// user access to first event interpretation (the file is now argument of the constructor!)\\
{\bf\red PaxEventInterpret* ei = new PaxEventInterpret(}{\bf\blue file}{\bf\red);}\\
// an empty event interpretation indicates the end-of-event \\
{\bf\red if (!ei--$>$IsEmpty()) ei--$>$Print(); }\\
{\bf\red delete ei; }\\
// ...more events... finally close and delete event file \\
{\bf\red file--$>$Close();}\\
{\bf\red delete file;}\\



%%% Local Variables: 
%%% mode: latex
%%% TeX-master: "paxguide"
%%% End: 
